SystemOrganization addCategory: #'A4BP-SimEngine-core'!

MooseEntity subclass: #BPSimScenario
	instanceVariableNames: 'id name description created modified author vendor version result inherits elementParameter scenarioParameter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core'!

!BPSimScenario commentStamp: 'SergeStinckwich 3/6/2015 11:41' prior: 0!
In BPSim process analysis data is used to provide complementary information to a BPMN or XPDL business process model in the context of process analysis, simulation and optimization. Business process
models and their business process elements are external sources. Scenarios within the process analysis data are always in reference to a single business process model (note that many processes can be captured into a single BPMN or XPDL business process model). Thus the business process model is a separately defined fixed point with variations possible on scenarios.

Scenarios can be used to capture:
a) input parameter specification for analysis, simulation and optimization;
b) results from analysis, simulation and optimization;
c) historical data from past real world execution of the business process model.

Scenarios of results will often reference a scenario of input specification (i.e. the results for the referenced input set).

It is possible for a scenario to overload or augment (inherit from) another scenario. In such case, only the changes to the element parameters values, or the added element parameters and their values, need to be
specified in the inheriting scenario.

A scenario is composed of a collection of element parameters. Each element parameter of a scenario references a specific element of a process within the business process model.

Each scenario may possess scenario parameters.
An extension capability is provided to the BPSim data. Both scenarios and element parameters can be extended with proprietary vendor extensions.!

!BPSimScenario class methodsFor: 'meta' stamp: 'SergeStinckwich 3/6/2015 11:38'!
annotation
	<abstract>
	<MSEClass: #BPSimScenario super: #MooseEntity>
	<package: #BPSim>! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/6/2015 11:47'!
description
	<MSEProperty: #description type: #String>
	<MSEComment: 'A description of this scenario'>
	^ description! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/6/2015 11:43'!
id
	^ id! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/6/2015 11:46'!
name
	<MSEProperty: #name type: #String>
	<MSEComment: 'A name for this scenario'>
	^ name! !
